#ifndef __POINTPICKER__H__
#define __POINTPICKER__H__

#include <iostream>

#include <qobject.h>

#include <Inventor/SoPickedPoint.h>
#include <Inventor/lists/SoPickedPointList.h>

#include <Inventor/nodes/SoNode.h>

#include <Inventor/actions/SoRayPickAction.h>
#include <Inventor/actions/SoWriteAction.h>

#include <vector>

using namespace std;

//! Allows picking of points on an object
class pointPicker : public QObject {
  Q_OBJECT
public:
  pointPicker();
  SbBool pickPointFromViewport(SoNode *root,
                               const SbViewportRegion &viewport,
                               const SbVec2s &cursorPosition,
                               SbBool haveTexture=FALSE,
                               const SbVec2f &textureScaleFactor=NULL,
                               float min=0);
signals:
  void texturePicked(float absoluteTexture,
                     float adjustedTexture);
  void coordinatePicked(float xCoord,
                        float yCoord,
                        float zCoord,
                        int index);
  void coordinatesPicked(vector<int> indices);

};

#endif // __POINTPICKER__H__
